.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 50000

.data
;Dummy	db 1	; unaligned
Src1	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?...", 0
Src2	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos!...", 0
Srcs1	db "A string ?...", 0
Srcs2	db "A string !...", 0
LenSrc1	dd 1000
LenSrc2	dd 1000
LenSrcs1	dd 10
LenSrcs2	dd 10

.data?
Dest	db 100 dup(?)

.code
start:	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	REPEAT 3
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	lea esi, Src1
	lea edi, Src2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax, ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, 1000 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, 1000 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
	mov esi, offset Src1
	mov edi, offset Src2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, 1000 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		mov ecx, LenSrc1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, 1000 bytes", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, 1000 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src1
		lea edi, Src2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, 1000 bytes", 13, 10, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	lea esi, Srcs1
	lea edi, Srcs2
	movzx eax, BYTE ptr [esi]
	movzx ebx, BYTE ptr [edi]
	.While eax == ebx
@@:		or eax,ebx
		jz @F
		inc esi
		inc edi
		movzx eax, BYTE ptr [esi]
		movzx ebx, BYTE ptr [edi]
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for qWord, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
	mov esi, offset Srcs1
	mov edi, offset Srcs2
	.While 1
		movzx eax, BYTE ptr [esi]
		movzx edx, BYTE ptr [edi]
		.Break .if eax!=edx
		.Break .if !eax
		.Break .if !edx
		inc esi
		inc edi
	.Endw
@@:
	counter_end
	print str$(eax), 9, "cycles for movzx check null, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		mov ecx, LenSrcs1
		repe cmpsb
	counter_end
	print str$(eax), 9, "cycles for repe cmpsb, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke lstrcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for lstrcmp, 10 bytes", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; 10-byte source
		lea esi, Srcs1
		lea edi, Srcs2
		invoke crt_strcmp, esi, edi
	counter_end
	print str$(eax), 9, "cycles for crt_strcmp, 10 bytes", 13, 10, 10
	ENDM
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
